#! /usr/bin/python

# Demo of API for https://www.fax2.com.au
# 
# Set the variables below as appropriate:

from fax2 import Fax2API
import os
import time
from credentials import username,password;

fax2 = Fax2API()
fax2.credentials(username,password)

POLL_INTERVAL = 60

# 300 seconds is the maximum guaranteed by the API specification, from
# a new entry's received_at time and the latest received_at time
# returned so far.
MARGIN = 300

last_received_at = time.time()
last_seen = set()

while True:
	try:
		faxlist = fax2.received_faxes(from_time=last_received_at)
		if faxlist:
			for entry in faxlist:
				faxid = entry['id']
				if not faxid in last_seen:
					receive_time = time.strftime("%Y%m%d%H%M",time.localtime(entry['received_at']))
					filename ="received-%s-%s.pdf" % (receive_time,faxid)
					if os.path.exists(filename):
						print "%s already exists, skipping" % filename
					else:
						fax2.write_fax_pdf_data(faxid,filename)
						print "received fax %s written as %s" % (faxid,filename)
					last_seen.add(faxid)
			
			# As a shortcut, prune the last_seen set by replacing it
			# with the ids from this response.
			last_seen = set([entry['id'] for entry in faxlist])

			new_last_received_at = max([entry['received_at'] for entry in faxlist])
			last_received_at = max(new_last_received_at-MARGIN,last_received_at)
	except Exception as e:
		print "Exception caught:"
		print e

	time.sleep(POLL_INTERVAL)
